#include "mainwindow.h"
#include "ui_mainwindow.h"

MainWindow::MainWindow(QWidget *parent) :
   QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    qsrand(time(0));
    ui->setupUi(this);
    setTable();
}

MainWindow::~MainWindow()
{
    delete ui;
}

//This function will generate the passwords and they will be insert into the tabla
void MainWindow::setTable()
{
    //qsrand(time(0));
    strings<<"A"<<"B"<<"C"<<"D"<<"E"<<"F"<<"G"<<"H"<<"I"<<"J"<<"K"<<"L"<<"M"<<"N"<<"O"<<"P"<<"Q"<<"R"<<"S"<<"T"<<"U"<<"V"<<"W"<<"X"<<"Y"<<"Z";//QList of Capital Letters
    Small_strings<<"a"<<"b"<<"c"<<"d"<<"e"<<"f"<<"g"<<"h"<<"i"<<"j"<<"k"<<"l"<<"m"<<"n"<<"o"<<"p"<<"q"<<"r"<<"s"<<"t"<<"u"<<"v"<<"w"<<"x"<<"y"<<"z";//QList of Small Letters
    Numbers<<"1"<<"2"<<"3"<<"4"<<"5"<<"6"<<"7"<<"8"<<"9"<<"0";//QList of Numbers
    Symbols<<"!"<<"#"<<"$"<<"%"<<"&"<<"/"<<"("<<")"<<"?"<<"<"<<">"<<"@"<<"*"<<","<<"."<<"("<<")"<<"="<<"["<<"]"<<"{"<<"}";//QList of Symbols

    int opt;
    for(int i=0;i<15;i++)
    {
        for(int j=0;j<8;j++)
        {
            QFont fondo;//Para poner las letras en negrita
            fondo.setBold(false);

           if(j==0)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::white);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }
           else if(j==1)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::darkCyan);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }
           else if(j==2)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::magenta);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }
           else if(j==3)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::green);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }
           else if(j==4)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::yellow);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }
           else if(j==5)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::blue);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }
           else if (j==6)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::lightGray);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }
           else if(j==7)
           {
               opt=qrand()%4+1;
               QString mes=get_Character(opt);
               QTableWidgetItem *item=new QTableWidgetItem(mes);
               item->setBackgroundColor(Qt::cyan);
               item->setFont(fondo);
               ui->tableWidget->setItem(j,i,item);
           }

        }
    }
}

//Funcion que me permite tener cualquier caracter de los QList. (Los caracteres salen aleatoriamente)
QString MainWindow::get_Character(int opt)
{
    //qsrand(QTime::currentTime().msec());
    int Capital_Letter,Small_Letter,Symbol,Number;
    switch(opt)
    {
    case 1:
        Capital_Letter=qrand()% strings.count();
        return strings.at(Capital_Letter);
        break;
    case 2:
        Small_Letter=qrand()%Small_strings.count();
        return Small_strings.at(Small_Letter);
        break;
    case 3:
        Symbol=qrand()%Symbols.size();
        return Symbols.at(Symbol);
        break;
    case 4:
        Number=qrand()%Numbers.count();
        return Numbers.at(Number);
        break;
    }
    return "Error";
}

void MainWindow::changeEvent(QEvent *e)
{
    QMainWindow::changeEvent(e);
    switch (e->type()) {
    case QEvent::LanguageChange:
        ui->retranslateUi(this);
        break;
    default:
        break;
    }
}



void MainWindow::on_pb_Generate_clicked()
{
    setTable();
}



